#define _GNU_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <dlfcn.h>
#include <string.h>
#include <err.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <limits.h>

char *getpass(const char *prompt)
{
	char * (*real_getpass)(const char *prompt) = NULL;
	char *env;
	FILE *fp;
	//char *str;
	char str[_SC_PASS_MAX];

	//warnx("intercepted \"%s\"", prompt);

	if(real_getpass == NULL)
	{
		void *handle = dlopen("/lib/i386-linux-gnu/libc.so.6", RTLD_LAZY);
		if (handle == NULL)
			errx(1, "dlopen: %s", dlerror());
		real_getpass = dlsym(handle, "getpass");
		if (real_getpass == NULL)
			errx(1, "dlopen: %s", dlerror());
	}

	env = getenv("CUPS_PASSWORD");
	if(env != NULL)
	{
		return env;
	}
	else
	{
		env = getenv("CUPS_ASKPASS");
		if(env != NULL)
		{
			fp = popen(env, "r");
			if(fp != NULL)
			{
				//str = malloc(_SC_PASS_MAX);
				fscanf(fp, "%s", &str);
				if(pclose(fp) == 0)
				{
					return str;
				}
				else
				{
					warnx("running %s failed", env);
				}
			}
			else
			{
				warn("popen: %s", env);
			}
		}
		else
		{
			warnx("Neither CUPS_PASSWORD or CUPS_ASKPASS are set.");
		}
	}
	
	return real_getpass(prompt);
}

